#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "config.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "tar.h"
char *tarexe,*exe[8194];
float tarlen=0;
int i;
void tarCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.tar.Intern==1)
	internTar(saveas);
  else
	externTar(saveas);
}

void tarParseOptions(){
  tarexe=(char*)malloc(2048);
  memset(tarexe,0x0,sizeof(tarexe));
//  strcpy(tarexe,methods.tar.Exe);
  strcpy(tarexe,"--append");
  exe[1]=tarexe;
/*  if(methods.tar.FailRead==1){
	strcpy(temp,"--ignore-failed-read");
	exe[i++]=temp;
  }
  if(methods.tar.ForceOwner==1){
	sprintf(temp,"--owner=%s",methods.tar.Owner);
	exe[i++]=temp;
  }
  if(methods.tar.ForceGroup==1){
	sprintf(temp,"--group=%s",methods.tar.Group);
	exe[i++]=temp;
  }
  if(methods.tar.IgnoreZero==1){
	strcpy(temp,"-i");
	exe[i++]=temp;
  }*/
/*  if(methods.tar.AbsNames==1){
	tarexe=(char*)malloc(1024);
	strcpy(tarexe,"-P");
	exe[i++]=tarexe;
	free(tarexe);
  }*/
/*  if(methods.tar.PosixArchive==1){
	strcpy(temp,"--posix");
	exe[i++]=temp;
  }
  if(methods.tar.V7Archive==1){
	strcpy(temp,"--old-archive");
	exe[i++]=temp;
  }
  if(methods.tar.NewFormat==1){
    strcpy(temp,"-g");
	exe[i++]=temp;
  }
  if(methods.tar.OldFormat==1){
	strcpy(temp,"-G");
	exe[i++]=temp;
  }
  if(methods.tar.DerefLinks==1){
	strcpy(temp,"-h");
	exe[i++]=temp;
  }
  if(methods.tar.RecThru==0){
	strcpy(temp,"--no-recursion");
	exe[i++]=temp;
  }
  if(methods.tar.Local==1){
	strcpy(temp,"-l");
	exe[i++]=temp;
  }*/
}

void externTar(char *saveas){
  FILE *fp;
  char *buffer,*temp;
  char temp2[256];
  int status=0,j=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
  for(tarlen=0;;tarlen++){
	if(cancelled==1)
	  break;
	if(gtk_clist_get_text(GTK_CLIST(lstTo),tarlen,0,&buffer)==0)
  	  break;
  	else{
  	  fp=fopen(buffer,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/11);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  tarParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/10);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.tar.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/9);
  	  while(gtk_events_pending())
        gtk_main_iteration();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/8);
  	  while(gtk_events_pending())
      gtk_main_iteration();
//	  exe[i++]=tarexe;
	  sprintf(temp,"--file=%s",saveas);
	  exe[2]=temp;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
      while(gtk_events_pending())
        gtk_main_iteration();	
	  exe[3]=buffer;
	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
      while(gtk_events_pending())
        gtk_main_iteration();
//	  printf("%s\n",exe);	
//	  for(j=0;j<i;j++)
//		printf("%s\n",exe[j]);
  	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),tarlen);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),buffer);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",tarlen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
        gtk_main_iteration();
	}
  }
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
	if(methods.tar.Verify==1){
	  memset(exe,0x0,sizeof(exe));
	  exe[0]=methods.tar.Exe;
	  exe[1]="-T";
	  exe[2]=saveas;
	  status=mySystem(exe);
	  if(status!=0){
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG02,strlen(ZERR_MSG02));
		gtk_widget_show(errMessage);
	  }else{
		gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size+=10);
		gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),"Testing the archive");
		while(gtk_events_pending())
  	  	  gtk_main_iteration();	
		gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ZERR_MSG03,strlen(ZERR_MSG03));
		gtk_widget_show(errMessage);
	  }
	}
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),tarlen+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));
//  gtk_clist_remove(GTK_CLIST(lstTo),tarlen);
	gdk_threads_leave();
  }
}

int internTar(char *saveas){
  return 0;
}  
