#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "config.h"
char* getHomeDir(){
  struct passwd *user=getpwuid(getuid());
  char *fileName=(char*)malloc(strlen(user->pw_dir)+1+strlen(".Zippi.conf"));
  strcpy(fileName,user->pw_dir);
  strcat(fileName,"/");
  strcat(fileName,".Zippi.conf");
  return fileName;
}

void readFile(){
  FILE *fp;
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  char *configName;
  configName=getHomeDir();
  if((fp=fopen(configName,"r"))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG06,strlen(ERR_MSG06));
	gtk_widget_show(errMessage);
	writeFile();
  }else
	fread(&methods,sizeof(methods),1,fp);
}

void writeFile(){
  FILE *fp;
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  char *configName;
  configName=getHomeDir();
  if((fp=fopen(configName,"w"))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG07,strlen(ERR_MSG07));
	gtk_widget_show(errMessage);
	exit(0);
  }else
	fwrite(&methods,sizeof(methods),1,fp);
}